<?php

/*
 * Basic hostmask encryption.
 * This code is made for irc.ftou.gr by Aris Agrippas
 * Copyright (c) 2006
 */

function makehost($hst) {
	// weird static hosts
	// xxx.gov.gr
    if (strpos($hst,"gov.gr")) return "hidden.gov.gr";
    // xxx.ftou.gr
    if (strpos($hst,"ftou.gr")) return $hst;
    // companyname.isp.gr
    if (preg_match ("/^[a-z\.]*$/i", $hst)){
    	$hst = ereg_replace('^.[a-zA-Z]*\.', '*', $hst);
    	return $hst;
    }
    
    // Most common types of hosts:
    if (is_numeric(str_replace(".", "", $hst))){
        $intDotPos = strrpos($hst,".") + 1;
        $hst = substr($hst, 0, $intDotPos) . "*";
    } else {
        // remove the numbers and the words "static, dynamic, ppp"
        $hst = ereg_replace('[0-9-]|static|dynamic|ppp', '*', $hst);
        // remove instances of ".*" and "*."
        $hst = ereg_replace('\.\*|\*\.', '*', $hst);
        // chop off any double ** - make it single:
        $hst = ereg_replace('\*\**', '*', $hst);
    }
    return $hst;
}
?>
