<?php

/*
 * IRC channel topic format.
 * This code is made for irc.ftou.gr by Aris Agrippas
 * Copyright (c) 2006
 */

function maketopic($topic) {
    
    $strToReplace = array('/</','/>/',"/'/",'/"/');
    $strReplacemt = array('&lt;', '&gt;', "'", '&quot;');
    $topic = preg_replace($strToReplace, $strReplacemt, $topic);
	
	// counters    
    $i = 0;
    $num_bold = 0;
    $num_underline = 0;
    $num_colors = 0;

    while (strlen(strpos($topic, chr(2)))){ // chr(2) = ctrl+b for BOLD
        $i++;
        if ($i % 2 == 1){
            $topic = preg_replace('/' . chr(2) . '/', '<strong>', $topic, 1);
            $num_bold++;
        } else {
            $topic = preg_replace('/' . chr(2) . '/', '</strong>', $topic, 1);
            $num_bold--;
        }
    }

    $i = 0;

    while (strlen(strpos($topic, chr(31)))){ // chr(31) = ctrl+U for UNDERLINE
        $i++;
        if ($i % 2 == 1){
            $topic = preg_replace('/' . chr(31) . '/', '<u>', $topic, 1);
            $num_underline++;
        } else {
            $topic = preg_replace('/' . chr(31) . '/', '</u>', $topic, 1);
            $num_underline--;
        }
    }

    $colors = array("white", "black", "navy", "green", "red", "maroon", 
                        "purple", "orange", "yellow", "lime", "teal", "cyan", 
                        "blue", "magenta", "gray", "silver");

    // replace colours: ctrl+K = chr(3)
    $num_colors += preg_match_all("/" . chr(3) . "[0-9]/", $topic, $armcol);
    
    if (strlen(strpos($topic, chr(3)))){
        for($i = 15; $i >= 0; $i--){
            for($j = 15; $j >= 0; $j--){
                $toReplace = chr(3) . '0?' . $i . ',' . '0?' . $j;
                $strNew = '<span style="color:' . $colors[$i] . '; background-color:' . $colors[$j] . '">';
                $topic = preg_replace('/' . $toReplace . '/', $strNew, $topic);
            }
        }
        for($i = 15; $i >= 0; $i--){
            $toReplace = chr(3) . '0?' . $i;
            $strNew = '<span style="color:' . $colors[$i] . '">';
            $topic = preg_replace('/' . $toReplace . '/', $strNew, $topic);
        }
    }
		
    if ($num_colors > 0) $num_colors -= preg_match_all('/' . chr(3) . '/',$topic, $armcolclose);
    $topic = preg_replace('/' . chr(3) . '/', '</span>', $topic);

    // deal with any remaining unclosed spans:
    for ($i = 0; $i < $num_bold; $i++){
    	$topic .= '</strong>';
    }
    for ($i = 0; $i < $num_underline; $i++){
      	$topic .= '</u>';
    }
    for ($i = 0; $i < $num_colors; $i++){
      	$topic .= '</span>';
    }
    
	// fix to avoid very long words that break our lovely page layout
	$topic = preg_replace("/[a-zA-Z0-9.,!;\"$?_*()%\^&'#@+=<>\[\]~{|\\}Ÿǹɺϼվ-]{25,}/s", 'ftgr_lng_w', $topic);
    return $topic;
}

?>
